当前位置:   article > 正文

C# CAD2016 宗地生成界址点,界址点编号及排序

C# CAD2016 宗地生成界址点,界址点编号及排序


1 、界址点起点位置
C# CAD2016 多边形顶点按方向重新排序

 2、 界址点顺时针逆时针走向

C# CAD2016 判断多边形的方向正时针或逆时针旋转

 3、块文件插入

  1. //已知块文件名称 GXGLQTC
  2. //块文件需要插入的坐标点 scaledPoint
  3. // 插入块到当前图纸中的指定位置
  4. ObjectId newBlockId;
  5. BlockTable currentBlockTable = tr.GetObject(db.BlockTableId, OpenMode.ForWrite) as BlockTable;
  6. newBlockId = currentBlockTable["GXGLQTC"];
  7. using (Transaction transaction = db.TransactionManager.StartTransaction())
  8. {
  9. BlockReference blockRef = new BlockReference(scaledPoint, newBlockId);
  10. BlockTable bt = transaction.GetObject(db.BlockTableId, OpenMode.ForRead) as BlockTable;
  11. BlockTableRecord activeSpace = transaction.GetObject(bt[BlockTableRecord.ModelSpace], OpenMode.ForWrite) as BlockTableRecord;
  12. activeSpace.AppendEntity(blockRef);
  13. transaction.AddNewlyCreatedDBObject(blockRef, true);
  14. transaction.Commit();
  15. }
 4、主要步骤
  1. 获取当前活动文档、数据库和编辑器对象。
  2. 设置一个选择过滤器,只允许用户选择"宗地"图层上的LWPOLYLINE对象。
  3. 用户根据过滤规则进行实体选择后,程序处理所选中的每个闭合多段线。
  4. 对于每个闭合多段线,首先确保它是闭合的且至少有一个顶点,并将所有顶点存储到一个列表中。
  5. 注释部分:这部分原来包含计算多边形方向和排序顶点的逻辑,但后来被注释掉,实际代码中并没有执行这部分操作。
  6. 遍历排序后的顶点列表,为每个顶点创建一个文本标签(DBText)并在模型空间中绘制,标签内容是其顺序编号,位置基于顶点坐标并进行了缩放和平移处理。
  7. 同样针对每个顶点,在模型空间中插入名为“GXGLQTC”的块参照,并将其定位在与文本标签相同的位置。

另外,还提供了一个辅助方法GetCenterOfPolyline,用于计算给定多段线的中心点,但在当前代码片段中并未使用此方法来确定文本标签或块参照的位置。

 5、完整代码

  1. namespace cad自定义面板集.jzd
  2. {
  3. internal class jzd01
  4. {
  5. // 选定"宗地"图层上的封闭对象(例如闭合多段线)
  6. [CommandMethod("GenerateBoundaryPoints")]
  7. public static void GenerateBoundaryPoints()
  8. {
  9. // 获取当前活动文档和数据库
  10. // 获取当前AutoCAD应用中的活动文档、数据库和编辑器对象
  11. Document doc = Application.DocumentManager.MdiActiveDocument;
  12. Database db = doc.Database;
  13. Editor ed = doc.Editor;
  14. // 创建一个选择过滤器,限制用户只能选择"宗地"图层上的LWPOLYLINE对象作为外部边界
  15. SelectionFilter outerFilter = new SelectionFilter(new TypedValue[] {
  16. new TypedValue((int)DxfCode.Start, "LWPOLYLINE"),
  17. new TypedValue((int)DxfCode.LayerName, "宗地")
  18. });
  19. // 提示用户根据上述规则进行实体选择,并获取选择结果
  20. PromptSelectionResult outerSelRes = ed.GetSelection(outerFilter);
  21. // 检查用户是否成功选择了实体
  22. if (outerSelRes.Status == PromptStatus.OK)
  23. {
  24. using (Transaction tr = db.TransactionManager.StartTransaction())// 开始事务处理以确保数据一致性
  25. {
  26. foreach (ObjectId outerId in outerSelRes.Value.GetObjectIds())// 遍历所有被选中的外部多段线
  27. {
  28. Polyline outerPolyline = (Polyline)tr.GetObject(outerId, OpenMode.ForRead);
  29. // 确保所选多段线是闭合的且至少有一个顶点
  30. if (outerPolyline.Closed && outerPolyline.NumberOfVertices > 0)
  31. {
  32. List<Point2d> sortedOuterPoints = new List<Point2d>();
  33. for (int i = 0; i < outerPolyline.NumberOfVertices; i++)
  34. {
  35. Point2d point = outerPolyline.GetPoint2dAt(i);
  36. sortedOuterPoints.Add(point);
  37. }
  38. 多边形顶点集合outerPoints的边界框
  39. //var boundingBox = outerPoints.Aggregate(
  40. // new { MinX = double.MaxValue, MaxX = double.MinValue, MinY = double.MaxValue, MaxY = double.MinValue },
  41. // (a, b) =>
  42. // {
  43. // return new
  44. // {
  45. // MinX = Math.Min(a.MinX, b.X),
  46. // MaxX = Math.Max(a.MaxX, b.X),
  47. // MinY = Math.Min(a.MinY, b.Y),
  48. // MaxY = Math.Max(a.MaxY, b.Y)
  49. // };
  50. // });
  51. 找到左上角的顶点作为候选西北角
  52. //Point2d topLeftCorner = new Point2d(boundingBox.MinX, boundingBox.MaxY);
  53. 找到最接近左上角(西北方向)的顶点索引
  54. //int startVertexIndex = outerPoints.IndexOf(outerPoints.OrderBy(p => Math.Pow(p.X - topLeftCorner.X, 2) + Math.Pow(p.Y - topLeftCorner.Y, 2)).First());
  55. 确保起始顶点是真正的西北角,并按照顺时针排序
  56. //bool isClockwiseFromNorthwest = true;
  57. //int j = outerPoints.Count - 1;
  58. //double sum = 0;
  59. //for (int i = 0; i < outerPoints.Count - 1 || (i == outerPoints.Count - 2 && j == outerPoints.Count - 1); i++)
  60. //{
  61. // // Shoelace公式的实现,计算三角形对角线乘积之和
  62. // if (i != outerPoints.Count - 2 || j != outerPoints.Count - 1)
  63. // {
  64. // sum += (outerPoints[j].X - outerPoints[i].X) * (outerPoints[(j + 1) % outerPoints.Count].Y + outerPoints[i].Y);
  65. // }
  66. // else
  67. // {
  68. // // 处理最后一个三角形,连接最后一个顶点和第一个顶点
  69. // sum += (outerPoints[j].X - outerPoints[i].X) * (outerPoints[0].Y + outerPoints[i].Y);
  70. // }
  71. // // 更新下一次迭代的索引值(注意这里在循环体内部更新j以正确处理最后一个元素之后的“下一个”顶点)
  72. // j = i;
  73. //}
  74. //ed.WriteMessage(sum + "sum\n");
  75. 根据有符号面积判断多边形的方向
  76. //if (sum > 0)
  77. //{
  78. // isClockwiseFromNorthwest = false;
  79. //}
  80. //else
  81. //{
  82. // isClockwiseFromNorthwest = true;
  83. //}
  84. //ed.WriteMessage(isClockwiseFromNorthwest + "方向\n");
  85. 创建一个新的列表,包含从西北角开始按顺时针顺序排列的顶点
  86. //List<Point2d> sortedOuterPoints = new List<Point2d>();
  87. //if (!isClockwiseFromNorthwest)
  88. //{
  89. // ed.WriteMessage(isClockwiseFromNorthwest + "方向1");
  90. // // 如果原始顺序不是从西北角开始顺时针排列,则反转整个列表并重新调整起始点位置
  91. // var reversedOuterPoints = outerPoints.ToList();
  92. // reversedOuterPoints.Reverse();//反序
  93. // sortedOuterPoints.AddRange(reversedOuterPoints);
  94. // sortedOuterPoints.RemoveAt(sortedOuterPoints.Count - 1); // 移除最后一个顶点(与第一个顶点重叠)
  95. // sortedOuterPoints.Insert(0, outerPoints[startVertexIndex]);
  96. //}
  97. //else
  98. //{
  99. // ed.WriteMessage(isClockwiseFromNorthwest + "方向2");
  100. // // 否则直接使用原始列表并调整起始顶点位置
  101. // sortedOuterPoints.AddRange(outerPoints.Skip(startVertexIndex));
  102. // sortedOuterPoints.Insert(0, outerPoints[startVertexIndex]);
  103. //}
  104. // 使用sortedOuterPoints进行后续操作
  105. if (sortedOuterPoints.Count > 0)
  106. {
  107. Dictionary<Point2d, int> pointIndexDict = new Dictionary<Point2d, int>();
  108. for (int i = 0; i < sortedOuterPoints.Count; i++)
  109. {
  110. // 创建并设置文本对象
  111. Point2d point = sortedOuterPoints[i];
  112. // 获取多边形的中心点
  113. Point3d center = GetCenterOfPolyline(outerPolyline);
  114. // 定义你的扩展因子,比如 1.5 表示扩大1.5倍
  115. double scaleFactor = 1.1;
  116. // 将顶点向中心点平移,然后按比例缩放
  117. Point3d scaledPoint = new Point3d(
  118. (point.X - center.X) * scaleFactor + center.X,
  119. (point.Y - center.Y) * scaleFactor + center.Y,
  120. 0
  121. );
  122. scaledPoint = new Point3d(point.X, point.Y,0);
  123. DBText text = new DBText();
  124. text.TextString = "T"+(i + 1).ToString();
  125. text.Height = 0.85;
  126. text.Position = scaledPoint;
  127. // 将文本添加到模型空间
  128. using (Transaction transaction = db.TransactionManager.StartTransaction())
  129. {
  130. BlockTable bt = transaction.GetObject(db.BlockTableId, OpenMode.ForRead) as BlockTable;
  131. BlockTableRecord ms = transaction.GetObject(bt[BlockTableRecord.ModelSpace], OpenMode.ForWrite) as BlockTableRecord;
  132. ms.AppendEntity(text);
  133. transaction.AddNewlyCreatedDBObject(text, true);
  134. transaction.Commit();
  135. }
  136. // 插入块到当前图纸中的指定位置
  137. ObjectId newBlockId;
  138. BlockTable currentBlockTable = tr.GetObject(db.BlockTableId, OpenMode.ForWrite) as BlockTable;
  139. newBlockId = currentBlockTable["GXGLQTC"];
  140. using (Transaction transaction = db.TransactionManager.StartTransaction())
  141. {
  142. BlockReference blockRef = new BlockReference(scaledPoint, newBlockId);
  143. BlockTable bt = transaction.GetObject(db.BlockTableId, OpenMode.ForRead) as BlockTable;
  144. BlockTableRecord activeSpace = transaction.GetObject(bt[BlockTableRecord.ModelSpace], OpenMode.ForWrite) as BlockTableRecord;
  145. activeSpace.AppendEntity(blockRef);
  146. transaction.AddNewlyCreatedDBObject(blockRef, true);
  147. transaction.Commit();
  148. }
  149. }
  150. }
  151. }
  152. }
  153. tr.Commit();
  154. }
  155. }
  156. }
  157. private static Point3d GetCenterOfPolyline(Polyline polyline)
  158. {
  159. double xSum = 0, ySum = 0, zSum = 0;
  160. for (int i = 0; i < polyline.NumberOfVertices; i++)
  161. {
  162. Point3d vertex = polyline.GetPoint3dAt(i);
  163. xSum += vertex.X;
  164. ySum += vertex.Y;
  165. zSum += vertex.Z;
  166. }
  167. return new Point3d(xSum / polyline.NumberOfVertices, ySum / polyline.NumberOfVertices, zSum / polyline.NumberOfVertices);
  168. }
  169. }
  170. }

 

//感谢大家的点赞,收藏,转发,关注 
//附送AI 图片无版权 随意用 龙年大吉大利
通义万相        阿里最新推出的A绘画创作模型 

声明:本文内容由网友自发贡献,不代表【wpsshop博客】立场,版权归原作者所有,本站不承担相应法律责任。如您发现有侵权的内容,请联系我们。转载请注明出处:https://www.wpsshop.cn/w/小蓝xlanll/article/detail/93051
推荐阅读
相关标签
  

闽ICP备14008679号